# empty debugsourcefiles.list
%global debug_package %{nil}

%global install_prefix %{_libdir}/rocm/llvm

%define major %(echo %{version} | cut -d. -f1)
%define minor %(echo %{version} | cut -d. -f2)
%define minus %(echo %{version} | cut -d. -f3)

Name:           mixbench
Version:        0.0.4
Release:        %mkrel 2
Summary:        GPU/CPU benchmark tools
Group:          System/Kernel and hardware
Url:            https://github.com/ekondis/mixbench
License:        GPLv2
Source0:        https://github.com/ekondis/mixbench/archive/v%{version}/%{name}-%{major}.%{minor}%{minus}.tar.gz

Patch1:         mixbench-0.04-opencl-path.patch

BuildRequires:  chrpath
BuildRequires:  cmake
BuildRequires:  pkgconfig(OpenCL)
BuildRequires:  rocm-hip
BuildRequires:  rocm-llvm-devel

ExclusiveArch:  x86_64


%description
A GPU benchmark tool for evaluating GPUs and CPUs on mixed operational intensity kernels
(CUDA, OpenCL, HIP, SYCL, OpenMP)


%package -n %{name}-opencl
Summary:        Benchmark tool for OpenCL
Group:          System/Kernel and hardware

%description -n %{name}-opencl
OpenCL benchmark tool from MixBench tool series


%package -n %{name}-hip
Summary:        Benchmark tool for OpenCL
Group:          System/Kernel and hardware
Requires:       rocm-hip

%description -n %{name}-hip
HIP benchmark tool from MixBench tool series


%prep
%autosetup -p1 -n %{name}-%{major}.%{minor}%{minus}

%build
%cmake \
    -S "./mixbench-opencl" \
    -B build-ocl

%define _vpath_builddir build-ocl
%cmake_build


export ROCM_PATH=%{_prefix}
%cmake \
    -S "./mixbench-hip" \
    -B build-hip \
    -DCMAKE_HIP_ARCHITECTURES="OFF"

%define _vpath_builddir build-hip
%cmake_build

# Fix BS error mixbench-hip-ro contains a standard runpath /usr/lib
chrpath --delete build-hip/mixbench-hip-ro

%install
install -Dm755 build-ocl/mixbench-ocl-ro %{buildroot}%{_bindir}/mixbench-ocl-ro
ln -s %{_bindir}/mixbench-ocl-ro %{buildroot}%{_bindir}/mixbench-opencl
#squidf: FIXME to be moved out from bindir
install -Dm644 build-ocl/mix_kernels_ro.cl %{buildroot}%{_bindir}/mix_kernels_ro.cl

install -Dm755 build-hip/mixbench-hip-ro %{buildroot}%{_bindir}/mixbench-hip-ro
ln -s %{_bindir}/mixbench-hip-ro %{buildroot}%{_bindir}/mixbench-hip

%files -n %{name}-opencl
%license LICENSE
%doc README.md
%{_bindir}/mixbench-ocl-ro
%{_bindir}/mixbench-opencl
%{_bindir}/mix_kernels_ro.cl

%files -n %{name}-hip
%license LICENSE
%doc README.md
%{_bindir}/mixbench-hip-ro
%{_bindir}/mixbench-hip


%changelog
* Sun Dec 22 2024 daviddavid <daviddavid> 0.0.4-2.mga10
+ Revision: 2128958
- fix FTBFS

* Fri Jan 12 2024 squidf <squidf> 0.0.4-1.mga10
+ Revision: 2030483
- Fix BS error related to rpath
- Exclusive arch x86_64
-First package for Mageia; upstream version 0.04

